// interface.js

// Self called function to start on file include
(() => {
	document.addEventListener("DOMContentLoaded", () => {
		createTabsPersistant('tabs-ifaces-conf');
	});
})();

// Init function on iface tab load
function initIfaceTabForm(index, label="")
{
	setSelect(
		'#index-' + index,
		{
			settings: {
				placeholderText: globals.lang.SELECT_INTERFACE || 'Select interface',
				searchText: globals.lang.SELECT_NO_INTERFACES_AVAILABLE || 'No interface available',
			},
		}
	);
	setSelect('#type-' + index);
	setFormClientValidation('.ui-tabs-panel form');

    $('#is_vlan-' + index).on('change', function() {
		const isDisabled = !$(this).is(':checked');

        $('#vlan-' + index).prop("disabled", isDisabled);

		if(!isDisabled)
		{
			$('#vlan-' + index).focus();
		}
    });

	updateIface(index);
	openDelIfaceDialog(index, label);

	$('#is_dhcp-' + index).on('change', function() {
		const isDisabled = $(this).is(':checked');

        $('#ip_addr-' + index).prop("disabled", isDisabled);
		$('#netmask-' + index).prop("disabled", isDisabled);
		$('#gateway-' + index).prop("disabled", isDisabled);
    });
}

// Update interface form
function updateIface(index)
{
	$('#updateIface-' + index).submit(async e => {
		e.preventDefault();

		try {
			const formData = getFormValues('updateIface-' + index);

			const success = await ajaxPromiseJSON({
				url: 'display.php',
				data: {
					action: 'updateIface',
					jsonKey: index.replace('_', '.'), // Replace html replacement char _ by the . used in the jsonFile
					...formData,
				},
			});

			setSessionMessage([], success);

			location.reload();
		} catch (err) {
			displayUserMessage(err);
		}
	});
}

// Open delete iface confirmation dialog
function openDelIfaceDialog(index, label)
{
	$('#deleteIface-' + index).on('click', async function() {
		$(this).blur();

		openDialogByAJAX(
			'dialog.php',
			{
				action: 'deleteIface',
				jsonKey: index.replace('_', '.'),
			},
			globals.lang.DELETE + ' - ' + label,
			'dialog-info',
			{
				resizable: false,
				draggable: false,
				width: 'auto',
				position: {
					my: "right top",
					at: "right bottom",
					of: $(this),
				},
			},
		);
	});
}
